ProgressMonitorInputStream (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing, class: ProgressMonitorInputStream
Keywords: javax.swing.ProgressMonitorInputStream class

# Class ProgressMonitorInputStream

java.lang.Object
java.io.InputStream
java.io.FilterInputStream
javax.swing.ProgressMonitorInputStream

All Implemented Interfaces:
  `Closeable, AutoCloseable`

public class ProgressMonitorInputStream extends FilterInputStream
Monitors the progress of reading from some InputStream. This ProgressMonitor is normally invoked in roughly this form:

    InputStream in = new BufferedInputStream(
                             new ProgressMonitorInputStream(
                                     parentComponent,
                                     "Reading " + fileName,
                                     new FileInputStream(fileName)));

This creates a progress monitor to monitor the progress of reading the input stream. If it's taking a while, a ProgressDialog will be popped up to inform the user. If the user hits the Cancel button an InterruptedIOException will be thrown on the next read. All the right cleanup is done when the stream is closed.

For further documentation and examples see How to Monitor Progress, a section in The Java Tutorial.

Since:
  1.2
See Also:
  - `ProgressMonitor`
  - `JOptionPane`

- ## Field Summary

  ### Fields declared in class FilterInputStream

  `in`
  Modifier and Type
  Field
  Description
  `protected InputStream`
  `in`
  The input stream to be filtered.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ProgressMonitorInputStream(Component parentComponent, Object message, InputStream in)`
  Constructs an object to monitor the progress of an input stream.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Overrides `FilterInputStream.close` to close the progress monitor as well as the stream.
  `ProgressMonitor`
  `getProgressMonitor()`
  Get the ProgressMonitor object being used by this stream.
  `int`
  `read()`
  Overrides `FilterInputStream.read` to update the progress monitor after the read.
  `int`
  `read(byte[] b)`
  Overrides `FilterInputStream.read` to update the progress monitor after the read.
  `int`
  `read(byte[] b, int off, int len)`
  Overrides `FilterInputStream.read` to update the progress monitor after the read.
  `void`
  `reset()`
  Overrides `FilterInputStream.reset` to reset the progress monitor as well as the stream.
  `long`
  `skip(long n)`
  Overrides `FilterInputStream.skip` to update the progress monitor after the skip.

  ### Methods declared in class FilterInputStream

  `available, mark, markSupported`
  Modifier and Type
  Method
  Description
  `int`
  `available()`
  Returns an estimate of the number of bytes that can be read (or skipped over) from this input stream without blocking by the next caller of a method for this input stream.
  `void`
  `mark(int readlimit)`
  Marks the current position in this input stream.
  `boolean`
  `markSupported()`
  Tests if this input stream supports the `mark` and `reset` methods.

  ### Methods declared in class InputStream

  `nullInputStream, readAllBytes, readNBytes, readNBytes, skipNBytes, transferTo`
  Modifier and Type
  Method
  Description
  `static InputStream`
  `nullInputStream()`
  Returns a new `InputStream` that reads no bytes.
  `byte[]`
  `readAllBytes()`
  Reads all remaining bytes from the input stream.
  `int`
  `readNBytes(byte[] b, int off, int len)`
  Reads the requested number of bytes from the input stream into the given byte array.
  `byte[]`
  `readNBytes(int len)`
  Reads up to a specified number of bytes from the input stream.
  `void`
  `skipNBytes(long n)`
  Skips over and discards exactly `n` bytes of data from this input stream.
  `long`
  `transferTo(OutputStream out)`
  Reads all bytes from this input stream and writes the bytes to the given output stream in the order that they are read.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### ProgressMonitorInputStream

    public ProgressMonitorInputStream(Component parentComponent, Object message, InputStream in)
    Constructs an object to monitor the progress of an input stream.
    Parameters:
      `parentComponent` - The component triggering the operation being monitored.
      `message` - Descriptive text to be placed in the dialog box if one is popped up.
      `in` - The input stream to be monitored.

- ## Method Details

  - ### getProgressMonitor

    public ProgressMonitor getProgressMonitor()
    Get the ProgressMonitor object being used by this stream. Normally this isn't needed unless you want to do something like change the descriptive text partway through reading the file.
    Returns:
      the ProgressMonitor object used by this object

  - ### read

    public int read() throws IOException
    Overrides `FilterInputStream.read` to update the progress monitor after the read.
    Overrides:
      `read` in class `FilterInputStream`
    Returns:
      the next byte of data, or `-1` if the end of the stream is reached.
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `FilterInputStream.in`

  - ### read

    public int read(byte[] b) throws IOException
    Overrides `FilterInputStream.read` to update the progress monitor after the read.
    Overrides:
      `read` in class `FilterInputStream`
    Parameters:
      `b` - the buffer into which the data is read.
    Returns:
      the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `FilterInputStream.read(byte[], int, int)`

  - ### read

    public int read(byte[] b, int off, int len) throws IOException
    Overrides `FilterInputStream.read` to update the progress monitor after the read.
    Overrides:
      `read` in class `FilterInputStream`
    Parameters:
      `b` - the buffer into which the data is read.
      `off` - the start offset in array `b` at which the data is written.
      `len` - the maximum number of bytes to read.
    Returns:
      the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `FilterInputStream.in`

  - ### skip

    public long skip(long n) throws IOException
    Overrides `FilterInputStream.skip` to update the progress monitor after the skip.
    Overrides:
      `skip` in class `FilterInputStream`
    Parameters:
      `n` - the number of bytes to be skipped.
    Returns:
      the actual number of bytes skipped.
    Throws:
      `IOException` - if `in.skip(n)` throws an IOException.
    See Also:
      - `InputStream.skipNBytes(long)`

  - ### close

    public void close() throws IOException
    Overrides `FilterInputStream.close` to close the progress monitor as well as the stream.
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `FilterInputStream`
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `FilterInputStream.in`

  - ### reset

    public void reset() throws IOException
    Overrides `FilterInputStream.reset` to reset the progress monitor as well as the stream.
    Overrides:
      `reset` in class `FilterInputStream`
    Throws:
      `IOException` - if this stream has not been marked or if the mark has been invalidated.
    See Also:
      - `FilterInputStream.in`
      - `FilterInputStream.mark(int)`